// component/dialog-input/dialog-input.js
Component({
  /**
   * Component properties
   */
  properties: {
    title: {
      type: String,
      value: ''
    },

    btn: {
      type: Object,
      value: {}
    },

    msg: {
      type: Array,
      value: [],
      observer(newVal, _) {
        let btnDisabled = false
        newVal.forEach(v => {
          if (!v.hasValue && v.txt === '') {
            btnDisabled = true
          }
        })

        this.setData({
          btnDisabled
        })
      }
    },

    show: {
      type: Boolean,
      value: false,
      observer(newVal, oldVal) {
        if (newVal === oldVal) {
          return
        }
        if (newVal) {
          this.setData({
            isShow: true
          })
          const animation1 = wx.createAnimation({
            duration: 400,
            timingFunction: 'linear'
          })
          animation1.opacity(1).step()

          const animation2 = wx.createAnimation({
            duration: 500,
            timingFunction: 'linear'
          })
          animation2.opacity(1).step()
          this.setData({
            bgAnimationData: animation1.export(),
            animationData: animation2.export()
          })
        } else {
          const animation1 = wx.createAnimation({
            duration: 400,
            timingFunction: 'linear'
          })
          animation1.opacity(0).step()

          const animation2 = wx.createAnimation({
            duration: 500,
            timingFunction: 'linear'
          })

          animation2.opacity(0).step()
          this.setData({
            bgAnimationData: animation1.export(),
            animationData: animation2.export()
          })

          const that = this
          setTimeout(() => {
            that.setData({
              isShow: false
            })
          }, 500)
        }
      }
    }
  },

  /**
   * Component initial data
   */
  data: {
    btnDisabled: false,
    name: '',
    animationData: {},
    bgAnimationData: {},
    isShow: false
  },

  /**
   * Component methods
   */
  methods: {
    cancel() {
      this.triggerEvent('cancel', !this.data.show)
    },

    nameInput(e) {
      this.setData({
        name: e.detail.value
      })
    },

    getPhoneNumber(e) {
      this.triggerEvent('getPhoneNumber', e.detail)
    },

    submit() {
      this.triggerEvent('submit', { name: this.data.name })
    }
  },

  pageLifetimes: {
    // 组件所在页面的生命周期函数
    show() {}
  }
})
